routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::middleware(['auth'])->group(function () {
    Route::get('/home', 'HomeController@index')->name('home');
    Route::resource('department', DepartmentController::class);
    Route::resource('jenis-surat', JenisSuratController::class);
    Route::resource('user', UserController::class);
    Route::resource('nomor-surat', NomorSuratController::class);
});

app/Models/NomorSurat.php
<?php

/**
 * Created by Reliese Model.
 */

namespace App\Models;

use Carbon\Carbon;
use Illuminate\Database\Eloquent\Model;

/**
 * Class NomorSurat
 * 
 * @property int $id
 * @property string $tahun
 * @property int $department_id
 * @property int $jenis_surat_id
 * @property string $nomor_surat
 * @property Carbon|null $created_at
 * @property Carbon|null $updated_at
 * 
 * @property Department $department
 * @property JenisSurat $jenis_surat
 *
 * @package App\Models
 */
class NomorSurat extends Model
{
	protected $table = 'nomor_surats';

	protected $casts = [
		'department_id' => 'int',
		'jenis_surat_id' => 'int'
	];

	protected $fillable = [
		'tahun',
		'department_id',
		'jenis_surat_id',
		'nomor_surat'
	];

	public function department()
	{
		return $this->belongsTo(Department::class);
	}

	public function jenis_surat()
	{
		return $this->belongsTo(JenisSurat::class);
	}
}

app/Http/Controllers/NomorSuratController.php
<?php

namespace App\Http\Controllers;

use DB;
use App\Models\Department;
use App\Models\JenisSurat;
use App\Models\NomorSurat;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class NomorSuratController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $listNomor = NomorSurat::with('department', 'jenis_surat')->get();

        return view('pages.nomor-surat.index', compact('listNomor'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $listDepartment = Department::get();
        $listJenis = JenisSurat::get();
        $tahun = date('Y');
        $nomorSuratCount = NomorSurat::get()->count();
        $squence = sprintf("%04d", $nomorSuratCount + 1);

        return view('pages.nomor-surat.create', compact('tahun', 'listJenis', 'listDepartment', 'squence'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'tahun' => 'required',
            'department_id' => 'required',
            'jenis_surat_id' => 'required',
            'nomor_surat' => 'required',
        ]);

        DB::beginTransaction();
        try {

            $department = Department::where('kode_department', $request->department_id)->first();
            $jenisSurat = JenisSurat::where('kode_surat', $request->jenis_surat_id)->first();

            NomorSurat::create([
                'tahun' => $request->tahun,
                'department_id' => $department->id,
                'jenis_surat_id' => $jenisSurat->id,
                'nomor_surat' => $request->nomor_surat,
            ]);
            
            DB::commit();
            return redirect(route('nomor-surat.index'))->with('info', 'berhasil di proses');
        } catch (\Throwable $th) {
            //throw $th;
            DB::rollback();
            return redirect()->back()->withInput()->withErrors('gagal input data');
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $idNomor = \Crypt::decrypt($id);
        $nomorSurat = NomorSurat::findorfail($idNomor);

        $listDepartment = Department::get();
        $listJenis = JenisSurat::get();
        $squence = substr($nomorSurat->nomor_surat, -4);
        
        return view('pages.nomor-surat.edit', compact('nomorSurat', 'listDepartment', 'listJenis', 'squence'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'tahun' => 'required',
            'department_id' => 'required',
            'jenis_surat_id' => 'required',
            'nomor_surat' => 'required',
        ]);

        DB::beginTransaction();
        try {

            $department = Department::where('kode_department', $request->department_id)->first();
            $jenisSurat = JenisSurat::where('kode_surat', $request->jenis_surat_id)->first();

            $idNomor = \Crypt::decrypt($id);
            $nomorSurat = NomorSurat::findorfail($idNomor);
            $nomorSurat->tahun = $request->tahun;
            $nomorSurat->department_id = $department->id;
            $nomorSurat->jenis_surat_id = $jenisSurat->id;
            $nomorSurat->nomor_surat = $request->nomor_surat;
            $nomorSurat->save();
            
            DB::commit();
            return redirect(route('nomor-surat.index'))->with('info', 'berhasil di proses');
        } catch (\Throwable $th) {
            //throw $th;
            DB::rollback();
            return redirect()->back()->withInput()->withErrors('gagal input data');
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $idNomor = \Crypt::decrypt($id);
        $nomorSurat = NomorSurat::findorfail($idNomor);
        $nomorSurat->delete();

        return redirect(route('nomor-surat.index'))->with('info', 'berhasil di delete');
    }
}

resources/views/pages/nomor-surat/create.blade.php
@extends('layouts.app')

@section('title', 'Create Nomor Surat')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            @include('components.alert-info')

            @include('components.alert-error')

            <div class="card">
                <div class="card-header">{{ __('Create Nomor Surat') }}</div>

                <div class="card-body">
                    <form method="POST" action="{{ route('nomor-surat.store') }}">
                        @csrf
                        <input type="hidden" name="squence" id="squence" value="{{ $squence }}">

                        <div class="form-group row">
                            <label for="tahun" class="col-md-4 col-form-label text-md-right">{{ __('Tahun') }}</label>

                            <div class="col-md-6">
                                <input id="tahun" type="text" class="form-control @error('tahun') is-invalid @enderror" name="tahun" value="{{ old('tahun', $tahun) }}" required autocomplete="tahun" autofocus readonly>

                                @error('tahun')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="department_id" class="col-md-4 col-form-label text-md-right">{{ __('Nama Department') }}</label>

                            <div class="col-md-6">

                                <select id="department_id" class="form-control @error('department_id') is-invalid @enderror" name="department_id">
                                    <option value="">-- Pilih --</option>
                                    @foreach ( $listDepartment as $dep )
                                    <option value="{{ $dep->kode_department }}">{{ $dep->nama_department }}</option>
                                    @endforeach
                                </select>

                                @error('department_id')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="jenis_surat_id" class="col-md-4 col-form-label text-md-right">{{ __('Jenis Surat') }}</label>

                            <div class="col-md-6">
                                <select id="jenis_surat_id" class="form-control @error('jenis_surat_id') is-invalid @enderror" name="jenis_surat_id">
                                    <option value="">-- Pilih --</option>
                                    @foreach ( $listJenis as $dep )
                                    <option value="{{ $dep->kode_surat }}">{{ $dep->jenis_surat }}</option>
                                    @endforeach
                                </select>

                                @error('jenis_surat_id')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="nomor_surat" class="col-md-4 col-form-label text-md-right">{{ __('Nomor Surat') }}</label>

                            <div class="col-md-6">
                                <input id="nomor_surat" type="text" class="form-control @error('nomor_surat') is-invalid @enderror" name="nomor_surat" value="{{ old('nomor_surat') }}" required autocomplete="nomor_surat" autofocus readonly>

                                @error('nomor_surat')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>


                        <div class="form-group row mb-0">
                            <div class="col-md-6 offset-md-4">
                                <button type="submit" class="btn btn-primary">
                                    {{ __('Save') }}
                                </button>
                                <a href="{{ route('nomor-surat.index') }}">
                                <button type="button" class="btn btn-danger">
                                    {{ __('Cancel') }}
                                </button>
                                </a>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('script')
    <script src="{{ URL::asset('js/input-nomor.js') }}"></script>
@endsection

resources/views/pages/nomor-surat/edit.blade.php
@extends('layouts.app')

@section('title', 'Edit Nomor Surat')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            @include('components.alert-info')

            @include('components.alert-error')

            <div class="card">
                <div class="card-header">{{ __('Edit Nomor Surat') }}</div>

                <div class="card-body">
                    <form method="POST" action="{{ route('nomor-surat.update', \Crypt::encrypt($nomorSurat->id)) }}">
                        @csrf
                        <input type="hidden" name="_method" value="PUT">
                        <input type="hidden" name="squence" id="squence" value="{{ $squence }}">

                        <div class="form-group row">
                            <label for="tahun" class="col-md-4 col-form-label text-md-right">{{ __('Tahun') }}</label>

                            <div class="col-md-6">
                                <input id="tahun" type="text" class="form-control @error('tahun') is-invalid @enderror" name="tahun" value="{{ old('tahun', $nomorSurat->tahun) }}" required autocomplete="tahun" autofocus readonly>

                                @error('tahun')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="department_id" class="col-md-4 col-form-label text-md-right">{{ __('Nama Department') }}</label>

                            <div class="col-md-6">

                                <select id="department_id" class="form-control @error('department_id') is-invalid @enderror" name="department_id">
                                    <option value="">-- Pilih --</option>
                                    @foreach ( $listDepartment as $dep )
                                    @php
                                        $selected = ($dep->id == $nomorSurat->department_id) ? 'selected' : '';
                                    @endphp
                                    <option value="{{ $dep->kode_department }}" {{ $selected }}>{{ $dep->nama_department }}</option>
                                    @endforeach
                                </select>

                                @error('department_id')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="jenis_surat_id" class="col-md-4 col-form-label text-md-right">{{ __('Jenis Surat') }}</label>

                            <div class="col-md-6">
                                <select id="jenis_surat_id" class="form-control @error('jenis_surat_id') is-invalid @enderror" name="jenis_surat_id">
                                    <option value="">-- Pilih --</option>
                                    @foreach ( $listJenis as $dep )
                                    @php
                                        $selected = ($dep->id == $nomorSurat->jenis_surat_id) ? 'selected' : '';
                                    @endphp
                                    <option value="{{ $dep->kode_surat }}" {{ $selected }}>{{ $dep->jenis_surat }}</option>
                                    @endforeach
                                </select>

                                @error('jenis_surat_id')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="nomor_surat" class="col-md-4 col-form-label text-md-right">{{ __('Nomor Surat') }}</label>

                            <div class="col-md-6">
                                <input id="nomor_surat" type="text" class="form-control @error('nomor_surat') is-invalid @enderror" name="nomor_surat" value="{{ old('nomor_surat', $nomorSurat->nomor_surat) }}" required autocomplete="nomor_surat" autofocus readonly>

                                @error('nomor_surat')
                                    <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                @enderror
                            </div>
                        </div>


                        <div class="form-group row mb-0">
                            <div class="col-md-6 offset-md-4">
                                <button type="submit" class="btn btn-primary">
                                    {{ __('Save') }}
                                </button>
                                <a href="{{ route('nomor-surat.index') }}">
                                <button type="button" class="btn btn-danger">
                                    {{ __('Cancel') }}
                                </button>
                                </a>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('script')
    <script src="{{ URL::asset('js/input-nomor.js') }}"></script>
@endsection

resources/views/pages/nomor-surat/index.blade.php
@extends('layouts.app')

@section('title', 'Nomor Surat')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-12">
            @include('components.alert-info')

            @include('components.alert-error')

            <div class="card">
                <div class="card-header">{{ __('Nomor Surat') }}</div>

                <div class="card-body">
                    <div class="form-group row mb-4">
                        <div class="col-md-6">
                            <a href="{{ route('nomor-surat.create') }}">
                            <button type="button" class="btn btn-primary">
                                {{ __('Input Data') }}
                            </button>
                            </a>
                        </div>
                    </div>

                    <table id="nomor-surat" class="table table-striped table-bordered" style="width:100%">
                        <thead>
                            <tr>
                                <th>Tahun</th>
                                <th>Nama Department</th>
                                <th>Jenis Surat</th>
                                <th>Nomor Surat</th>
                                <th>Aksi</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach ( $listNomor as $item)
                            <tr>
                                <td>{{ $item->tahun }}</td>
                                <td>{{ $item->department->nama_department }}</td>
                                <td>{{ $item->jenis_surat->jenis_surat }}</td>
                                <td>{{ $item->nomor_surat }}</td>
                                <td>
                                    <form method="POST" action="{{ route('nomor-surat.destroy', \Crypt::encrypt($item->id)) }}">
                                    @csrf
                                    <input type="hidden" name="_method" value="DELETE">
                                    <div class="form-group row mb-0">
                                        <div class="col-md-12">
                                            <a href="{{ route('nomor-surat.edit', \Crypt::encrypt($item->id)) }}">
                                            <button type="button" class="btn btn-primary">
                                                {{ __('Edit') }}
                                            </button>
                                            </a>
                                            <button type="submit" class="btn btn-danger" onclick="return confirm('anda yakin mau delete?')">
                                                {{ __('Delete') }}
                                            </button>
                                        </div>
                                    </div>
                                    </form>
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                        <tfoot>
                            <tr>
                                <th>Tahun</th>
                                <th>Nama Department</th>
                                <th>Jenis Surat</th>
                                <th>Nomor Surat</th>
                                <th>Aksi</th>
                            </tr>
                        </tfoot>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('script')
    <script src="{{ URL::asset('js/department.js') }}"></script>
@endsection